/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/


void qascade_main::newGame()
{
	for(int count=0; count < 225; count++) {
		buttonColor[count] = rand()%3+1;
		buttonGroup->find(count)->setPixmap(*pixmaps[buttonColor[count]]);
	}
	scoreLabel->setText("0");
}

void qascade_main::init()
{
	for(int count=0; count < 225; count++) {
		buttonGroup->find(count)->setStyle("QWindowsStyle");
		buttonGroup->find(count)->setFocusPolicy(QWidget::NoFocus);
	}
	pixmaps[0] = new QPixmap(this->lookupPixmap("clear.png"));
	pixmaps[1] = new QPixmap(this->lookupPixmap("red.png"));
	pixmaps[2] = new QPixmap(this->lookupPixmap("green.png"));
	pixmaps[3] = new QPixmap(this->lookupPixmap("blue.png"));  
	srand(time(NULL));
	this->newGame();
}

void qascade_main::buttonClicked( int buttonid )
{
	checkColor = buttonColor[buttonid];
	if(checkColor == 0) {
		return;
	}
	thisScore = 1;
	nextNum = 2;
	// Clear Buttons
	this->buttonCheck(buttonid,false);
	// Move Buttons Down
	for(int column = 0; column <225 ; column = column+9) {
		for(int row=7 ; row>-1; row--) {
			for(int below=row;below<8 ;below++) {
				if(buttonColor[column+below]==0 || buttonColor[column+below+1]!=0) {
					break;
				}
				buttonColor[column+below+1] = buttonColor[column+below];
				buttonGroup->find(column+below+1)->setPixmap(*pixmaps[buttonColor[column+below]]);
				buttonColor[column+below] = 0;
				buttonGroup->find(column+below)->setPixmap(*pixmaps[0]); 
			}
		}
	}
	// Move Buttons Left
	for(int column = 207; column >-1 ; column -= 9) {
		if((buttonColor[column]+buttonColor[column+1]+buttonColor[column+2]+buttonColor[column+3]+buttonColor[column+4]+buttonColor[column+5]+buttonColor[column+6]+buttonColor[column+7]+buttonColor[column+8])==0) {
			for (int buttonIter = column; buttonIter<216; buttonIter++) {
				buttonColor[buttonIter] = buttonColor[buttonIter+9];
				buttonGroup->find(buttonIter)->setPixmap(*pixmaps[buttonColor[buttonIter]]);
			}
			for (int finalIter =216; finalIter<225; finalIter++) {
				buttonColor[finalIter]=0;
				buttonGroup->find(finalIter)->setPixmap(*pixmaps[0]);
			}
		}
	}
	if(thisScore > 1) {
		scoreLabel->setText(QString::number(scoreLabel->text().toInt()+thisScore));
	}
	bool moveLeft=false;
	for(int count=0;count<225;count++) {
		checkColor=(buttonColor[count]==0 ? 4 : buttonColor[count]);
		if(this->buttonCheck(count,true)) {
			moveLeft=true;
			break;
		}
	}
	if(!moveLeft) {
		int buttonCount=0;
		for(int count=0; count < 225; count++) {
			buttonCount=buttonCount+buttonColor[count];
		}
		if(buttonCount==0){
			scoreLabel->setText(QString::number(scoreLabel->text().toInt()+500));
		}
		high_score *scoreDialog = new high_score();
		scoreDialog->setScore(scoreLabel->text().toInt());
		scoreDialog->exec();
		delete scoreDialog;
		this->newGame();
	}
}

bool qascade_main::buttonCheck( int buttonid, bool endCheck)
{
	if(buttonid>8 && buttonColor[buttonid-9]==checkColor) {
		if(endCheck) { return true; }
		buttonColor[buttonid] = 0;
		buttonGroup->find(buttonid)->setPixmap(*pixmaps[0]);
		buttonColor[buttonid-9] = 0;
		buttonGroup->find(buttonid-9)->setPixmap(*pixmaps[0]);
		this->buttonCheck(buttonid-9,false);
		thisScore += nextNum; nextNum++;
	}
	if(buttonid <216 && buttonColor[buttonid+9]==checkColor) {
		if(endCheck) { return true; }
		buttonColor[buttonid] = 0;
		buttonGroup->find(buttonid)->setPixmap(*pixmaps[0]);
		buttonColor[buttonid+9] = 0;
		buttonGroup->find(buttonid+9)->setPixmap(*pixmaps[0]);
		this->buttonCheck(buttonid+9,false);
		thisScore += nextNum; nextNum++;
	}
	if((double(buttonid/9)+0.1 < (double(buttonid)/9.0)) && buttonColor[buttonid-1] == checkColor) {
		if(endCheck) { return true; }
		buttonColor[buttonid] = 0;
		buttonGroup->find(buttonid)->setPixmap(*pixmaps[0]);
		buttonColor[buttonid-1] = 0;
		buttonGroup->find(buttonid-1)->setPixmap(*pixmaps[0]);
		this->buttonCheck(buttonid-1,false);
		thisScore += nextNum; nextNum++;
	}		
	if((double((buttonid+1)/9)+0.1 < double(buttonid+1)/9.0) && buttonColor[buttonid+1] == checkColor) {
		if(endCheck) { return true; }
		buttonColor[buttonid] = 0;
		buttonGroup->find(buttonid)->setPixmap(*pixmaps[0]);
		buttonColor[buttonid+1] = 0;
		buttonGroup->find(buttonid+1)->setPixmap(*pixmaps[0]);
		this->buttonCheck(buttonid+1,false);
		thisScore += nextNum; nextNum++;
	}		
	return false;
}


QPixmap qascade_main::lookupPixmap( QString name )
{
	const QMimeSource* mime_source = QMimeSourceFactory::defaultFactory()->data( name );
	
	if ( mime_source == 0 ) return QPixmap();
	
	QPixmap pixmap;
	QImageDrag::decode( mime_source, pixmap );
	return pixmap;
}


void qascade_main::showHighScores()
{
		high_score *scoreDialog = new high_score();
		scoreDialog->setScore(-1);
		scoreDialog->exec();
		delete scoreDialog;

}
